/* File name     : vs.h
 * Creation date : September 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Modified date : November 1994, Y.Yasu
 *               :   fix bug for Multiple V.S. modules
 */

#define  VS_ADDR 0x8000
#define  VS_SIZE 0x200
#define VS_MAX_CHANNEL 8
#define VS_MAX_STRING 16
#define VS_COLUMN 9
#define VS_CLEAR_ADDRESS 127

struct uplowlong {
    u_long upper;
    u_long lower;
};
union channel8data {
    u_short data[2];
    u_long ldata;
};
union channel4data {
    u_short data[4];
    struct uplowlong ldata;
};
struct ramdata {
    char string[VS_MAX_STRING];
};
union vs {
    u_short reg[VS_SIZE/sizeof(u_short)];
    union channel8data ch8[VS_MAX_CHANNEL];
    union channel4data ch4[VS_MAX_CHANNEL/2];
    struct ramdata ramdata[VS_COLUMN];
};
#if defined(ULTRIX) || defined(DEC)
long swapword( a )
u_short *a; {
    u_short i[2];

    i[1] = a[0]; i[0] = a[1];
    return( *(long *)i ) ;
}
swapbyte(twobyte)
char *twobyte;
{
    char c;

    c = twobyte[0];
    twobyte[0] = twobyte[1];
    twobyte[1] = c;
}
#endif
int bcd2i( iidata )
long *iidata;
{
  union {
    u_char ibyte[4];
    u_long ilong;
  } array;
  int i;
  u_char byte,hbyte,lbyte;
  u_long jdata=0;

  array.ilong = *iidata;
#if defined(ULTRIX) || defined(DEC)
  for( i = 3 ; i >= 0; i--) {
#else
#if defined(HPRT)
  for( i = 0; i <= 3; i++ ) {
#endif
#endif
    byte = array.ibyte[i];
    hbyte = (byte>>4) & 0xF;
    lbyte = byte & 0xF;
    jdata = jdata*10 + hbyte;
    jdata = jdata*10 + lbyte;
  }
  *iidata = (long)jdata;
}
